# phpDox - Source of State.php

# Source of file State.php

Size: 5,625 Bytes - Last Modified: 2020-04-17T14:56:27-04:00

## src/State.php

1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277

    <?php declare(strict_types=1);

    /**

     * Query

     *

     * SQL Query Builder / Database Abstraction Layer

     *

     * PHP version 7.4

     *

     * @package     Query

     * @author      Timothy J. Warren <tim@timshomepage.net>

     * @copyright   2012 - 2020 Timothy J. Warren

     * @license     http://www.opensource.org/licenses/mit-license.html  MIT License

     * @link        https://git.timshomepage.net/aviat/Query

     * @version     3.0.0

     */

    namespace Query;

    use function is_array;

    /**

     * Query builder state

     *

     * @method getSelectString(): string

     * @method getFromString(): string

     * @method getSetString(): string

     * @method getOrderString(): string

     * @method getGroupString(): string

     * @method getSetArrayKeys(): array

     * @method getOrderArray(): array

     * @method getGroupArray(): array

     * @method getValues(): array

     * @method getWhereValues(): array

     * @method getLimit(): int|null

     * @method getOffset()

     * @method getQueryMap(): array

     * @method getHavingMap(): array

     *

     * @method setSelectString(string $selectString): self

     * @method setFromString(string $fromString): self

     * @method setSetString(string $setString): self

     * @method setOrderString(string $orderString): self

     * @method setGroupString(string $groupString): self

     * @method setSetArrayKeys(array $arrayKeys): self

     * @method setGroupArray(array $array): self

     * @method setLimit(int $limit): self

     * @method setOffset(?int $offset): self

     */

    class State {

    	// --------------------------------------------------------------------------

    	// ! SQL Clause Strings

    	// --------------------------------------------------------------------------

    	/**

    	 * Compiled 'select' clause

    	 * @var string

    	 */

    	protected string $selectString = '';

    	/**

    	 * Compiled 'from' clause

    	 * @var string

    	 */

    	protected string $fromString = '';

    	/**

    	 * Compiled arguments for insert / update

    	 * @var string

    	 */

    	protected string $setString = '';

    	/**

    	 * Order by clause

    	 * @var string

    	 */

    	protected string $orderString = '';

    	/**

    	 * Group by clause

    	 * @var string

    	 */

    	protected string $groupString = '';

    	// --------------------------------------------------------------------------

    	// ! SQL Clause Arrays

    	// --------------------------------------------------------------------------

    	/**

    	 * Keys for insert/update statement

    	 * @var array

    	 */

    	protected array $setArrayKeys = [];

    	/**

    	 * Key/val pairs for order by clause

    	 * @var array

    	 */

    	protected array $orderArray = [];

    	/**

    	 * Key/val pairs for group by clause

    	 * @var array

    	 */

    	protected array $groupArray = [];

    	// --------------------------------------------------------------------------

    	// ! Other Class vars

    	// --------------------------------------------------------------------------

    	/**

    	 * Values to apply to prepared statements

    	 * @var array

    	 */

    	protected array $values = [];

    	/**

    	 * Values to apply to where clauses in prepared statements

    	 * @var array

    	 */

    	protected array $whereValues = [];

    	/**

    	 * Value for limit string

    	 * @var int

    	 */

    	protected ?int $limit = NULL;

    	/**

    	 * Value for offset in limit string

    	 * @var int

    	 */

    	protected ?int $offset = NULL;

    	/**

    	 * Query component order mapping

    	 * for complex select queries

    	 *

    	 * Format:

    	 * [

    	 *		'type' => 'where',

    	 *		'conjunction' => ' AND ',

    	 *		'string' => 'k=?'

    	 * ]

    	 *

    	 * @var array

    	 */

    	protected array $queryMap = [];

    	/**

    	 * Map for having clause

    	 * @var array

    	 */

    	protected array $havingMap = [];

    	public function __call(string $name, array $arguments)

    	{

    		if (strpos($name, 'get', 0) === 0)

    		{

    			$maybeProp = lcfirst(substr($name, 3));

    			if (isset($this->$maybeProp))

    			{

    				return $this->$maybeProp;

    			}

    		}

    		if (strpos($name, 'set', 0) === 0)

    		{

    			$maybeProp = lcfirst(substr($name, 3));

    			if (isset($this->$maybeProp))

    			{

    				$this->$maybeProp = $arguments[0];

    				return $this;

    			}

    		}

    		return NULL;

    	}

    	/**

    	 * @param string $str

    	 * @return State

    	 */

    	public function appendSelectString(string $str): self

    	{

    		$this->selectString .= $str;

    		return $this;

    	}

    	/**

    	 * @param array $setArrayKeys

    	 * @return State

    	 */

    	public function appendSetArrayKeys(array $setArrayKeys): self

    	{

    		$this->setArrayKeys = array_merge($this->setArrayKeys, $setArrayKeys);

    		return $this;

    	}

    	/**

    	 * @param string $key

    	 * @param mixed $orderArray

    	 * @return State

    	 */

    	public function setOrderArray(string $key, $orderArray): self

    	{

    		$this->orderArray[$key] = $orderArray;

    		return $this;

    	}

    	/**

    	 * @param string $groupArray

    	 * @return State

    	 */

    	public function appendGroupArray(string $groupArray): self

    	{

    		$this->groupArray[] = $groupArray;

    		return $this;

    	}

    	/**

    	 * @param array $values

    	 * @return State

    	 */

    	public function appendValues(array $values): self

    	{

    		$this->values = array_merge($this->values, $values);

    		return $this;

    	}

    	/**

    	 * @param mixed $val

    	 * @return State

    	 */

    	public function appendWhereValues($val): self

    	{

    		if (is_array($val))

    		{

    			foreach($val as $v)

    			{

    				$this->whereValues[] = $v;

    			}

    			return $this;

    		}

    		$this->whereValues[] = $val;

    		return $this;

    	}

    	/**

    	 * Add an additional set of mapping pairs to a internal map

    	 *

    	 * @param string $conjunction

    	 * @param string $string

    	 * @param string $type

    	 * @return State

    	 */

    	public function appendMap(string $conjunction = '', string $string = '', string $type = ''): self

    	{

    		$this->queryMap[] = [

    			'type' => $type,

    			'conjunction' => $conjunction,

    			'string' => $string

    		];

    		return $this;

    	}

    	/**

    	 * @param array $item

    	 * @return State

    	 */

    	public function appendHavingMap(array $item): self

    	{

    		$this->havingMap[] = $item;

    		return $this;

    	}

    }